C     PROGRAM SADIANA(INPUT,OUTPUT,TAPES=INPUT)
C     TEXAS A&M VERSION OF DECEMBER,1971
C     PROGRAM WRITTEN BY W. H. BAUR.
C     SADIAN, A PROGRAM BY W H BAUR. CALCULATES  BOND DISTANCES AND
C     BOND ANGLES IN CRYSTAL STRUCTURES.
C      SUBROUTINE SADIAN
      INTEGER XX1,XX2
      REAL*8 LABEL,LAB3,LAB1,LAB2
      LOGICAL*1 STIM(8),SDAT(9),NOM(16)
      VIRTUAL XDAM(54,3),TS(48,3,3),TTS(48,3),ATOM(99,3)
      VIRTUAL INGLE(22,99),REN(800,9),REH(800,3)
      DIMENSIONXX1(4),XX2(4),LAB3(99),LABEL(99)
      DIMENSIONCCELL(6),A(3),AS(3),ANG(3),ANGS(3),CASS(3),ORTB(9)
      DIMENSIONXMI(3),XMA(3),AMAX(99),ICOORD(99)
      DIMENSIONCAS(3),ANT(8,3),R(20),X1(4),XD(3),XDA(3),AX1(3
     * ),AX2(3)
      COMMON/SNORT/A,AS,ANG,ANGS,CAS,CASS,V,VS,CCELL,ORTB
      CALL DATE(SDAT)
      CALL TIME(STIM)
	TYPE 5739
5739  FORMAT('$Fichier de donnees : ')
      READ(5,5737)NCH,NOM
5737  FORMAT(Q,16A1)
      NOM(MIN0(16,NCH+1))=0
      CALL EXTEN(NOM,0,'DAT',NCH)
C	ASSIGNATION DU FICHIER D'ENTREE DU TYPE  ******.DAT
C      CALL ASSIGN(10,NOM,NCH,'RDO')
      OPEN(UNIT=10,NAME=NOM,TYPE='OLD')
      CALL EXTEN(NOM,1,'IMP',NCH)
C	ASSIGNATION DU FICHIER DE SORTIE DU TYPE ******.IMP
      OPEN(UNIT=15,NAME=NOM,TYPE='NEW')
      IN=10
	IOUT=15
      WRITE(IOUT,1358)SDAT,STIM
1358  FORMAT(1X,'DATE :  ',9A1,10X,'DEBUT D EXECUTION :  ',8A1//)
      E=.00001
      NA=0
      NF=0
2     READ(IN,180,END=250)(R(I),I=1,20)
4     WRITE(IOUT,182)(R(I),I=1,20)
      READ(IN,*)DMIN,DMAX,NAC,NT,NS,ICENT,NORT,NW,AMX
      WRITE(IOUT,500)NAC
310   DO1374J=1,NS
      READ(IN,*)(TTS(J,I),(TS(J,K,I),K=1,3),I=1,3)
1374  CONTINUE
      WRITE(IOUT,206)(J,(TTS(J,I),(TS(J,K,I),K=1,3),I=1,3),J=1,NS)
      READ(IN,*)CCELL
      CALLTRANS(IOUT)
      IF(NORT.NE.0)CALLCELLL(IOUT)
      IF(NAC.EQ.0)GOTO350
      READ(IN,196)(LABEL(I),(ATOM(I,I4),I4=1,3),I=1,NAC)
      NA=NA+NAC
350   WRITE(IOUT,186)NT,NS,ICENT,NORT
15    CONTINUE
      WRITE(IOUT,198)(I,LABEL(I),(ATOM(I,I4),I4=1,3),I=1,NA)
      IF(NT)14,14,18
14    DO16I3=1,3
16    ANT(1,I3)=0.0
      NT=1
      GOTO320
18    DO1375I=1,NT
      READ(IN,*)(ANT(I,I3),I3=1,3)
1375  CONTINUE
      WRITE(IOUT,202)(I,(ANT(I,I3),I3=1,3),I=1,NT)
320   WRITE(IOUT,226)
      IF(DMAX)22,22,24
22    WRITE(IOUT,208)
      GOTO26
24    WRITE(IOUT,210)DMAX
26    IF(NW)28,32,30
   28 WRITE(IOUT,212)AMX
      JAC=1
      JAD=1
      GOTO34
30    READ(IN,214)(AMAX(I),(INGLE(J,I),J=1,22),I=1,NW)
  214 FORMAT(F6.3,22I3)
      WRITE(IOUT,216)NW
      WRITE(IOUT,218)
      WRITE(IOUT,220)(I,AMAX(I),(INGLE(J,I),J=1,22),I=1,NW)
      GOTO34
32    WRITE(IOUT,222)
      JAC=0
      JAD=0
34    DSQM=DMAX**2
      ASQM=AMX**2
      WRITE(IOUT,224)
      DO36I=1,3
36    CAS(I)=2.0*CAS(I)
362   CONTINUE
      DO176I=1,NA
      WRITE(IOUT,226)
      IF(DMAX)40,40,38
38    WRITE(IOUT,2432)
      WRITE(IOUT,228)
2432  FORMAT(//31X,32(2H*.)/31X,32(2H.*)//)
   40 JAF=0
      JAM=1
      IF(NW)54,54,42
42    DO44JAA=1,NW
      IF(I-INGLE(1,JAA))44,46,44
44    CONTINUE
      JAC=0
      GOTO54
46    ASQM=AMAX(JAA)**2
      IF(INGLE(2,JAA))178,52,48
48    ING=INGLE(2,JAA)
      DO50JAB=1,ING
50    ICOORD(JAB)=INGLE(JAB+2,JAA)
      JAC=1
      GOTO54
52    JAC=-1
54    LAB1=LABEL(I)
      DO60IC=1,3
      IF(ATOM(I,IC))56,58,58
56    X1(IC)=2.0+AMOD(ATOM(I,IC),1.0)
      GOTO60
   58 X1(IC)=1.0+AMOD(ATOM(I,IC),1.0)
60    AX1(IC)=X1(IC)*A(IC)
      IF(DSQM-ASQM)62,62,64
62    QM=SQRT(ASQM)*1.5
      GOTO66
64    QM=SQRT(DSQM)*1.5
   66 DO68JAU=1,3
      XMI(JAU)=X1(JAU)-(QM/A(JAU))
68    XMA(JAU)=X1(JAU)+(QM/A(JAU))
      DO176II=1,NA
      IF(NW)78,78,70
70    IF(JAC)76,78,72
72    DO74JAB=1,ING
      IF(II-ICOORD(JAB))74,76,74
74    CONTINUE
      JAD=0
      GOTO78
76    JAD=1
   78 LAB2=LABEL(II)
      X21=ATOM(II,1)
      X22=ATOM(II,2)
      X23=ATOM(II,3)
      DO176J=1,NS
      DO80JJ=1,3
80    XD(JJ)=TTS(J,JJ)+X21*TS(J,1,JJ)+X22*TS(J,2,JJ)+X23*TS(J,3,JJ)
      DO176IA=1,NT
      DO86JJ=1,3
      XDA(JJ)=XD(JJ)+ANT(IA,JJ)
      IF(XDA(JJ))82,84,84
82    XDA(JJ)=1.0+AMOD(XDA(JJ),+1.0)
      GOTO86
   84 XDA(JJ)=AMOD(XDA(JJ),1.0)
86    CONTINUE
      A1=XDA(1)
      A2=A1+1.
      A3=A1+2.
      DO88IB=1,9
      XDAM(IB,1)=A1
      XDAM(IB+9,1)=A2
88    XDAM(IB+18,1)=A3
      A1=XDA(2)
      A2=A1+1.
      A3=A1+2.
      DO90ID=1,3
      XDAM(ID,2)=A1
      XDAM(ID+9,2)=A1
      XDAM(ID+18,2)=A1
      XDAM(ID+3,2)=A2
      XDAM(ID+12,2)=A2
      XDAM(ID+21,2)=A2
      XDAM(ID+6,2)=A3
      XDAM(ID+15,2)=A3
90    XDAM(ID+24,2)=A3
      A1=XDA(3)
      A2=A1+1.
      A3=A1+2.
      DO92IE=1,25,3
      XDAM(IE,3)=A1
      XDAM(IE+1,3)=A2
92    XDAM(IE+2,3)=A3
      IF(1-ICENT)98,94,94
94    DO96IG=1,3
      DO96IH=1,27
96    XDAM(IH+27,IG)=3.0-XDAM(IH,IG)
      NC=54
      GOTO100
98    NC=27
100   DO176IK=1,NC
      DO104JAT=1,3
      IF(XMI(JAT)-XDAM(IK,JAT))102,156,156
102   IF(XMA(JAT)-XDAM(IK,JAT))156,156,104
104   CONTINUE
      DO106IL=1,3
106   AX2(IL)=XDAM(IK,IL)*A(IL)
      DADA=AX1(1)-AX2(1)
      PAPA=AX1(2)-AX2(2)
      TATA=AX1(3)-AX2(3)
      DSQ=DADA**2+PAPA**2+TATA**2+DADA*PAPA*CAS(3)+DADA*TATA*CAS(2)+PAPA
     **TATA*CAS(1)
      IF(JAC)108,132,108
108   IF(JAD)132,132,110
110   IF(ASQM-DSQ)132,112,112
112   IF(JAF)178,118,114
114   DO116JAR=1,JAF
      IF(ABS(XDAM(IK,1)-REN(JAR,1)).LT.E.AND.ABS(XDAM(IK,2)-REN(JAR,2)).
     *LT.E.AND.ABS(XDAM(IK,3)-REN(JAR,3)).LT.E)GOTO156
116   CONTINUE
118   IF(ABS(DADA).LT.E.AND.ABS(PAPA).LT.E.AND.ABS(TATA).LT.E)GOTO156
  120 DD=SQRT(DSQ)
      JAF=JAF+1
      IF(JAF-800)126,126,122
122   WRITE(IOUT,230)
      STOP
  126 DO128JAG=1,3
128   REN(JAF,JAG)=XDAM(IK,JAG)
      LAB3(JAF)=LAB2
      REN(JAF,4)=DD
      REN(JAF,8)=DSQ
      DO130JAG=1,3
130   REN(JAF,JAG+4)=AX2(JAG)
  132 IF(DMAX)156,156,134
134   IF(DSQM-DSQ)156,136,136
136   IF(JAM-1)178,142,138
138   JAN=JAM-1
      DO140JAO=1,JAN
      IF(ABS(XDAM(IK,1)-REH(JAO,1)).LT.E.AND.ABS(XDAM(IK,2)-REH(JAO,2)).
     *LT.E.AND.ABS(XDAM(IK,3)-REH(JAO,3)).LT.E)GOTO156
140   CONTINUE
142   IF(ABS(DADA).LT.E.AND.ABS(PAPA).LT.E.AND.ABS(TATA).LT.E)GOTO156
144   D=SQRT(DSQ)
      IF(D.LT.DMIN)GOTO150
      IF(IK-27)146,146,148
146   WRITE(IOUT,232)LAB1,(X1(K),K=1,3),LAB2,(XDAM(IK,K),K=1,3),D,J,IA,
     *IKK
1460  FORMAT(2I3,F7.4)
      GOTO150
148   IKK=55-IK
      WRITE(IOUT,234)LAB1,(X1(K),K=1,3),LAB2,(XDAM(IK,K),K=1,3),D,J,IA,
     *IKK
150   IF(NORT.NE.0)CALLHOW(X1(1),X1(2),X1(3),XDAM(IK,1),XDAM(IK,2),XDAM(
     *IK,3),IOUT)
      DO152IREH=1,3
152   REH(JAM,IREH)=XDAM(IK,IREH)
      JAM=JAM+1
      IF(JAM-800)156,156,154
154   WRITE(IOUT,236)
      STOP
156   IF(JAC)158,176,158
158   IF(II-NA)176,160,178
160   IF(J-NS)176,162,178
162   IF(IA-NT)176,164,178
  164 IF(IK-NC)176,166,178
166   IF(JAF-1)176,176,168
168   JAL=JAF-1
      WRITE(IOUT,226)
      WRITE(IOUT,238)LAB1,LAB1,(X1(K),K=1,3)
      WRITE(IOUT,240)
      DO174JAK=1,JAL
      DO174JAH=JAK,JAL
      DDS=(REN(JAK,5)-REN(JAH+1,5))**2+(REN(JAK,6)-REN(JAH+1,6))**2+(REN
     *(JAK,7)-REN(JAH+1,7))**2+(REN(JAK,5)-REN(JAH+1,5))*(REN(JAK,6)-REN
     *(JAH+1,6))*CAS(3)+(REN(JAK,5)-REN(JAH+1,5))*(REN(KAF,7)-REN(JAH+1,
     *7))*CAS(2)+(REN(JAK,6)-REN(JAH+1,6))*(REN(JAK,7)-REN(JAH+1,7))*CAS
     *(1)
      COSA=(REN(JAK,8)+REN(JAH+1,8)-DDS)/(2.0*REN(JAK,4)*REN(JAH+1,4))
      CALLCHEK(COSA,IOUT)
      ALPHA=90.0-SIGN(ASIN(ABS(COSA)),COSA)*57.2957795
      DDR=SQRT(DDS)
      IF(REN(JAK,4).LT.DMIN.OR.REN(JAH+1,4).LT.DMIN)GOTO174
      WRITE(IOUT,242)LAB3(JAK),LAB1,LAB3(JAH+1),ALPHA,(REN(JAK,K),K=1,4)
     *,(REN(JAH+1,K),K=1,4),DDR
      IF(AMX)172,170,174
170   IF(AMAX(JAA))172,178,174
172   COSB=(DDS+REN(JAK,9)-REN(JAH+1,9))/(2.0*REN(JAK,5)*DDR)
      CALLCHEK(COSB,IOUT)
      BETA=90.0-SIGN(ASIN(ABS(COSB)),COSB)*57.2957795
      GAMMA=180.0-ALPHA-BETA
      WRITE(IOUT,244)LAB1,LAB3(JAK),LAB3(JAH+1),BETA,LAB1,LAB3(JAH+1),LA
     *B3(JAK),GAMMA
174   CONTINUE
176   CONTINUE
178   CONTINUE
  180 FORMAT(20A4)
  182 FORMAT(1X,20A4)
  186 FORMAT(1X,3HNT=I3,5X,3HNS=I3,5X,6HICENT=I3,5X,5HNORT=I3)
  196 FORMAT(A8,2X,3F10.6)
  198 FORMAT(' ATOMIC PARAMETERS         X           Y           Z'/(1X,
     *I3,2X,A8,5X,3F12.6))
  202 FORMAT(' TRANSLATIONS      X         Y         Z'/(1X,I3,10X,3F10.
     *4))
  206 FORMAT(' SYMMETRY POSITIONS       '/'             TTS(X)   TS(X)
     *             TTS(Y)   TS(Y)               TTS(Z)   TS(Z)'/(1X,I3,F
     *15.4,3F3.0,5X,F15.4,3F3.0,5X,F15.4,3F3.0))
  208 FORMAT(' NO DISTANCE TABLES WILL BE PRINTED    ')
  210 FORMAT(' TABLES WITH DISTANCES UP TO DMAX='F6.3,' WILL BE PRINTED
     *   ')
212   FORMAT(' BOND ANGLES AROUND ALL ATOMS WILL BE CALCULATED,     AMX=
     *'F6.3)
  216 FORMAT(////' BOND ANGLES AROUND'I3,' ATOMS WILL BE CALCULATED'//)
  218 FORMAT('         AMAX      CENTRAL    COORD.      COORDINATED'/'
     *                   ATOM     NUMBER                ATOMS  ')
  220 FORMAT(1X,I3,4X,F6.3,4X,I6,4X,I6,7X,20I3)
  222 FORMAT(' NO BOND ANGLES WILL BE CALCULATED')
  224 FORMAT(1H1)
  226 FORMAT(1X,///)
  228 FORMAT(' ATOM 1        X         Y         Z      ATOM 2        X
     *        Y         Z       DISTANCE   NS   NT   NC')
  230 FORMAT(' DIMENSION OF ARRAY REN HAS BEEN EXCEEDED')
  232 FORMAT(1X,A8,3F10.5,3X,A8,3F10.5,F11.4,3X,I3,2X,I3,2X,I3)
  234 FORMAT(1X,A8,3F10.5,3X,A8,3F10.5,F11.4,3X,I3,2X,I3,2X,I3,1H*)
  236 FORMAT(' DIMENSION OF ARRAY REH HAS BEEN EXCEEDED')
  238 FORMAT(' BOND ANGLES AROUND 'A8,' (IN DEGREES).',9X,'COORDINATES O
     *F ',A8,' X=',F7.5,4X,'Y=',F7.5,4X,'Z=',F7.5//)
  240 FORMAT('    A        CA         B         ANGLE        X(A)    Y(A
     *)    Z(A)     CA-A         X(B)    Y(B)    Z(B)     CA-B      A-B'
     *)
  242 FORMAT(1X,3(A8,2X),F8.2,5X,3F8.5,F9.4,5X,3F8.5,F9.4,F11.4)
  244 FORMAT(1X,3(A8,2X),F9.2,10X,3(A8,2X),F9.2)
  500 FORMAT(1X,10X,'NAC =',I5//)
250   CALL TIME(STIM)
      WRITE(IOUT,1359)STIM
1359  FORMAT(//1X,'FIN D EXECUTION : ',8A1)
      STOP
      END
      SUBROUTINECELLL(IOUT)
C     THIS SUBROUTINE WAS TAKEN FROM PROGRAM HOW
      COMMON/SNORT/A(3),AS(3),WA,WB,WC,ANGS(3),CWA,CWB,CWC,COSAS(3),V,VS
     *,CELL(6),ORTB(9)
   12 FORMAT(' ORTB(I) = ',10F10.4)
      RAD=180.0/3.141593
      WA=WA/RAD
      WB=WB/RAD
      WC=WC/RAD
      NORTH=2
      SWA=SIN(WA)
      SWB=SIN(WB)
      SWC=SIN(WC)
      BCMA=CWB*CWC-CWA
      CAMB=CWC*CWA-CWB
      ABMC=CWA*CWB-CWC
      VUNIT=V/(A(1)*A(2)*A(3))
      DO200I=1,9
200   ORTB(I)=0.0
      GOTO(201,202,203,204),NORTH
  201 ORTB(1)=1.
      ORTB(2)=CWC
      ORTB(3)=CWB
      ORTB(5)=SWC
      ORTB(6)=-BCMA/SWC
      ORTB(9)=VUNIT/SWC
      GOTO205
202   ORTB(1)=SWC
      ORTB(3)=-CAMB/SWC
      ORTB(4)=CWC
      ORTB(5)=1.0
      ORTB(6)=CWA
      ORTB(9)=VUNIT/SWC
      GOTO205
203   ORTB(1)=VUNIT/SWA
      ORTB(4)=CWC
      ORTB(5)=1.0
      ORTB(6)=CWA
      ORTB(7)=-CAMB/SWA
      ORTB(9)=SWA
      GOTO205
204   ORTB(1)=VUNIT/SWA
      ORTB(4)=-ABMC/SWA
      ORTB(5)=SWA
      ORTB(7)=CWB
      ORTB(8)=CWA
      ORTB(9)=1.0
  205 WRITE(IOUT,12)ORTB
      RETURN
      END
      SUBROUTINECHEK(X,IOUT)
      Y=ABS(X)
      IF(Y.GT.1.01)GOTO6
      IF(Y.LT.1.)GOTO4
    2 X=SIGN(1.,X)
4     RETURN
6     WRITE(IOUT,8)
    8 FORMAT('0     ABSOLUTE  VALUE  OF  ARGUMENT  OF  COS  OR  SIN  GRE
     *ATER  THAN  1.0')
      X=1.0
      RETURN
      END
C
      SUBROUTINETRANS(IOUT)
      DIMENSIONCELL(6),COSA(3),COSAS(3),ANG(3),ANGS(3),A(3),AS(3),ORT(9)
      COMMON/SNORT/A,AS,ANG,ANGS,COSA,COSAS,V,VS,CELL,ORT
      CONS1=(2.0*3.14159)/360.0
      CONS2=1.0/CONS1
      IF(CELL(4).LT.1.0)GOTO10
      DO5I=1,3
      CELL(I+3)=CELL(I+3)*CONS1
      COSA(I)=COS(CELL(I+3))
5     ANG(I)=CELL(I+3)
      GOTO20
10    DO15I=1,3
      COSA(I)=CELL(I+3)
15    ANG(I)=ACOS(CELL(I+3))
20    V=1.0-COSA(1)*COSA(1)-COSA(2)*COSA(2)-COSA(3)*COSA(3)
      V=V+2.0*COSA(1)*COSA(2)*COSA(3)
      V=CELL(1)*CELL(2)*CELL(3)*SQRT(V)
      DO25I=1,3
      A(I)=CELL(I)
      J=MOD(I,3)+1
      K=MOD(I+1,3)+1
      AS(I)=(CELL(J)*CELL(K)*SIN(ANG(I)))/V
25    COSAS(I)=(COSA(J)*COSA(K)-COSA(I))/(SIN(ANG(J))*SIN(ANG(K)))
      VS=1.0/V
      DO30I=1,3
      ANGS(I)=ACOS(COSAS(I))
      ANG(I)=ANG(I)*CONS2
30    ANGS(I)=ANGS(I)*CONS2
      I=1
      J=1
      IF(CELL(1).LT.1.0)I=4
      IF(CELL(1).GT.1.0)GOTO40
      DO35I=1,3
      TEMP=AS(I)
      AS(I)=A(I)
      A(I)=TEMP
      TEMP=ANGS(I)
      ANGS(I)=ANG(I)
      ANG(I)=TEMP
      TEMP=COSAS(I)
      COSAS(I)=COSA(I)
      COSA(I)=TEMP
      TEMP=VS
      VS=V
35    V=TEMP
40    WRITE(IOUT,2)A,ANG,COSA
      WRITE(IOUT,3)AS,ANGS,COSAS
      WRITE(IOUT,7)V,VS
      RETURN
    2 FORMAT(1H06X'A=',F8.3,5X'B=',F8.3,5X'C=',F8.3,7X'ALPHA=',F8.2,7X'B
     *ETA=',F8.2,7X'GAMMA=',F8.2/54X'COS(ALPHA)=',F9.6,5X'COS(BETA)=',F9
     *.6,5X'COS(GAMMA)=',F9.6///)
    3 FORMAT(1H05X'A*=',F8.5,4X'B*=',F8.5,4X'C*=',F8.5,7X'ALPHA*=',F8.2,
     *7X'BETA*=',F8.2,7X'GAMMA*=',F8.2/53X'COS(ALPHA*)=',F9.6,4X'COS(BET
     *A*)=',F9.6,4X'COS(GAMMA*)=',F9.6///)
    7 FORMAT(1H020X'VOLUME=',F8.2,17X'VOLUME*=',F10.6//)
      END
      SUBROUTINEHOW(X,Y,Z,U,V,W,IOUT)
      COMMON/SNORT/A(3),DUMMY(23),ORTB(9)
      DIMENSIONCX(6)
      CX(1)=X*A(1)*ORTB(1)+Y*A(2)*ORTB(2)+Z*A(3)*ORTB(3)
      CX(2)=X*A(1)*ORTB(4)+Y*A(2)*ORTB(5)+Z*A(3)*ORTB(6)
      CX(3)=X*A(1)*ORTB(7)+Y*A(2)*ORTB(8)+Z*A(3)*ORTB(9)
      CX(4)=U*A(1)*ORTB(1)+V*A(2)*ORTB(2)+W*A(3)*ORTB(3)
      CX(5)=U*A(1)*ORTB(4)+V*A(2)*ORTB(5)+W*A(3)*ORTB(6)
      CX(6)=U*A(1)*ORTB(7)+V*A(2)*ORTB(8)+W*A(3)*ORTB(9)
      WRITE(IOUT,100)CX
  100 FORMAT(8X,3F10.5,11X,3F10.5)
      RETURN
      END
	SUBROUTINE EXTEN(NFIL,MODE,EXT,NP)
	BYTE NFIL(1),MODE,EXT(1)
	DO 10 NP=1,16
	IF(NFIL(NP).EQ.0)GO TO 30
	IF(NFIL(NP).EQ.'.')GO TO 20
 10	CONTINUE
	RETURN
 20	IF(MODE.EQ.0)RETURN
	GO TO 40
 30	NFIL(NP)='.'
 40	DO 50 J=1,3
	IF(NP.GE.16)GO TO 60
	NP=NP+1
 50	NFIL(NP)=EXT(J)
 60	NFIL(MIN0(16,NP+1))=0
	END
